unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DXDraws, TiltIsoEngine, DXClass, DXInput;

type
  TForm1 = class(TForm)
    Engine: TIsoEngineGrid;
    Timer: TDXTimer;
    Input: TDXInput;
    procedure EngineInitialize(Sender: TObject);
    procedure TimerTimer(Sender: TObject; LagCount: Integer);
    procedure EngineAcabouMovimento(var MovObj: TMovObj);
  private
    { Private declarations }
  public
    procedure MoverBatman;
    procedure CarregarBase(nome: string);
    procedure CarregarCenario(nome: string);
    procedure MoverMonstros;        
  end;

type
  TParsedString = record
    strings: array of string;
    count: integer;
end;

const
  PDSUDESTE = 0;
  IFSUDESTE = 1;
  FFSUDESTE = 2;
  PDNORDESTE = 3;
  IFNORDESTE = 4;
  FFNORDESTE = 5;
  PDNOROESTE = 6;
  IFNOROESTE = 7;
  FFNOROESTE = 8;
  PDSUDOESTE = 9;
  IFSUDOESTE = 10;
  FFSUDOESTE = 11;
  PLSUDESTE = 12;
  PLNORDESTE = 13;
  PLNOROESTE = 14;
  PLSUDOESTE = 15;
  MAXTILES = 2;
  MAXINIMIGOS = 4;
  FRINIMORTO = 13;

var
  Form1: TForm1;

implementation
{$R *.DFM}


var
  batman: TMovObj;
  pulando: boolean;
  inimigos: array[0..MAXINIMIGOS -1] of TMovObj;
  bomba: TMovObj;
  perdeu: boolean;
  score: integer;

////////////////////////////////////////////////////////////////////////////////
//divide uma string em um array
//de strings, separados pelo "caract"
function ParseString(str, caract: string): TParsedString;
var
  p1: integer;
  b: boolean;
begin
  b:= false;
  result.count:= 0;
  while b = false do begin
    p1:= pos(caract, str);
    if (p1 = 0) or (p1 = -1) then break;
    setLength(result.strings, result.count + 1);
    result.strings[result.count]:= copy(str, 1, p1 -1);
    str:= copy(str, p1 + 1, length(str));
    result.count:= result.count + 1;
  end;
  if length(str) > 0 then begin
    setlength(result.strings, result.count + 1);
    result.strings[result.count]:= str;
    result.count:= result.count + 1;
  end;
end;


////////////////////////////////////////////////////////////////////////////////
procedure TForm1.MoverBatman;
var
  dir: TIsoDirecao;
begin
  dir:= idNenhum;

  //girar para a esquerda
  if isLeft in input.states then
  case batman.DirMov of
    idNordeste: dir:= idNoroeste;
    idNoroeste: dir:= idSudoeste;
    idSudoeste: dir:= idSudeste;
    idSudeste: dir:= idNordeste;
  end;

  //girar para a direita
  if isRight in input.states then
  case batman.DirMov of
    idNordeste: dir:= idSudeste;
    idNoroeste: dir:= idNordeste;
    idSudoeste: dir:= idNoroeste;
    idSudeste: dir:= idSudoeste;
  end;

  //atualizar a direo do movimento caso precise
  if (dir <> idNenhum) and (batman.ativa = false) and
     (pulando = false) then batman.DirMov:= dir;

  //atualizar direo do batman caso precise
  if (batman.ativa = false) and (pulando = false)
     then case dir of
    idNordeste: batman.CurFrame:= PDNORDESTE;
    idNoroeste: batman.CurFrame:= PDNOROESTE;
    idSudoeste: batman.curFrame:= PDSUDOESTE;
    idSudeste: batman.curFrame:= PDSUDESTE;
  end;

  //mover para frente
  if (isUp in input.states) and
     (batman.Ativa = false) and (pulando = false)
     then begin

     //testar direo para no colidir com bordas do mapa
     if (batman.DirMov = idNordeste) and
        (batman.CellY = 0) then exit;
     if (batman.dirMov = idNoroeste) and
        (batman.cellx = 0) then exit;
     if (batman.dirMov = idSudoeste) and
        (batman.CellY = engine.MaxLinhas -1) then exit;
     if (batman.dirMov = idSudeste) and
        (batman.CellX = engine.MaxColunas -1) then exit;

     //testar para no andar para dentro da rodovia
     if (batman.DirMov = idNordeste) and
        (batman.CellY = 6) then exit;
     if (batman.DirMov = idSudoeste) and
        (batman.CellY = 3) then exit;

     //testar para no atravessar qualquer cenrio
     case batman.dirMov of
      idNordeste: if engine.IsoCelula[batman.cellx,
         batman.celly -1].Frames.Ativa = true then exit;
      idNoroeste: if engine.IsoCelula[batman.cellx -1,
         batman.celly].Frames.Ativa = true then exit;
      idSudeste: if engine.IsoCelula[batman.cellx + 1,
         batman.celly].Frames.Ativa = true then exit;
      idSudoeste: if engine.IsoCelula[batman.cellx,
         batman.celly + 1].Frames.Ativa = true then exit;
     end;

     //pegar os frames de incio e fim da animao
     // baseado na direo em que o batman est virado
     case batman.DirMov of
       idNordeste: begin
         batman.IniFrame:= IFNORDESTE;
         batman.FimFrame:= FFNORDESTE;
       end;
       idNoroeste: begin
         batman.IniFrame:= IFNOROESTE;
         batman.FimFrame:= FFNOROESTE;
       end;
       idSudoeste: begin
         batman.IniFrame:= IFSUDOESTE;
         batman.FimFrame:= FFSUDOESTE;
       end;
       idSudeste: begin
         batman.IniFrame:= IFSUDESTE;
         batman.FimFrame:= FFSUDESTE;
       end;
     end;
     batman.Mover(batman.dirMov, true, 7, true, 1);
  end;

  //iniciar pulo
  if (isButton1 in input.States) and
     (batman.Ativa = false) and
     (pulando = false) then begin

     //testar direo para no colidir com bordas do mapa
     if (batman.DirMov = idNordeste) and
        (batman.CellY <= 2) then exit;
     if (batman.dirMov = idNoroeste) and
        (batman.cellx <= 2) then exit;
     if (batman.dirMov = idSudoeste) and
        (batman.CellY >= engine.MaxLinhas -3) then exit;
     if (batman.dirMov = idSudeste) and
        (batman.CellX >= engine.MaxColunas -3) then exit;

     //testar para no pular dentro da rodovia
     if (batman.DirMov = idNordeste) and
        ((batman.CellY = 7) or (batman.celly = 8)) then exit;
     if (batman.DirMov = idSudoeste) and
        ((batman.CellY = 2) or (batman.celly = 1)) then exit;

     //testar para no atravessar qualquer cenrio
     case batman.dirMov of
       idNordeste: if engine.IsoCelula[batman.cellx,
           batman.celly -3].Frames.Ativa = true then exit;
       idNoroeste: if engine.IsoCelula[batman.cellx -3,
           batman.celly].Frames.Ativa = true then exit;
       idSudeste: if engine.IsoCelula[batman.cellx + 3,
           batman.celly].Frames.Ativa = true then exit;
       idSudoeste: if engine.IsoCelula[batman.cellx,
           batman.celly + 3].Frames.Ativa = true then exit;
     end;
     //colocar o frame na direo em que o batman aponta
     case batman.DirMov of
       idNordeste: batman.CurFrame:= PLNORDESTE;
       idNoroeste: batman.CurFrame:= PLNOROESTE;
       idSudoeste: batman.CurFrame:= PLSUDOESTE;
       idSudeste: batman.CurFrame:= PLSUDESTE;
     end;
     batman.Mover(batman.dirMov, false, 14, false, 3);
     pulando:= true;
  end;

  //atirar
  if (isButton2 in input.states) and
     (batman.ativa = false) and
     (pulando = false) then begin
     bomba.x:= batman.X;
     bomba.Y:= batman.y;
     bomba.CurFrame:= 0;
     bomba.Mover(batman.dirMov, true, 7, true, 2);
     bomba.z:= 10;
  end;

end;


////////////////////////////////////////////////////////////////////////////////
procedure TForm1.MoverMonstros;
var
  i: integer;
  p: TPoint;
begin
  //rodar os monstros
  //se estiver desativado, ativ-lo em um lugar randmico do
  //mapa se no estiver se movendo, gir-lo e mov-lo um nmero
  //randmico de quadrados
  for i:= 0 to MAXINIMIGOS -1 do begin

    //se est desativado
    if inimigos[i].CurFrame = FRINIMORTO then begin

      //achar um local randmico do mapa
      p.x:= random(10);
      p.y:= random(10);
      while (p.y = 4) or (p.y = 5) or
        (engine.IsoCelula[p.x, p.y].AnimMode <> amNone) or
        (p.x = batman.CellX) or
        (p.y = batman.CellY) do begin
           p.x:= random(10);
           p.y:= random(10);
      end;
      inimigos[i].FramesAnim:= 0;

      //colocar o inimigo nesse local
      p:= engine.AcharPixel(p.x, p.y);
      inimigos[i].X:= p.x;
      inimigos[i].y:= p.y;

      //ativ-lo
      inimigos[i].DirMov:= idSudeste;
      inimigos[i].CurFrame:= PDSUDESTE;

      //passar para o prximo
      continue;
    end;

    //checar coliso com a bomba (matar monstro)
    if (bomba.CellX = inimigos[i].cellX) and
       (bomba.celly = inimigos[i].celly) and
       (bomba.CurFrame <> 3) then begin
         inimigos[i].CurFrame:= FRINIMORTO;
         inimigos[i].Ativa:= false;
         bomba.CurFrame:= 3;
         bomba.Ativa:= false;
         score:= score + 100;
         continue;
    end;
    if inimigos[i].curFrame = FRINIMORTO then continue;

    //se est ativado e no realizando movimento, mov-lo
    if inimigos[i].Ativa = true then continue;

    //girar para uma direo randmica
    case random(4) of
      0: inimigos[i].DirMov:= idNordeste;
      1: inimigos[i].DirMov:= idNoroeste;
      2: inimigos[i].DirMov:= idSudoeste;
      3: inimigos[i].DirMov:= idSudeste;
    end;

    //colocar o frame de parado, caso no seja
    // possvel mover o inimigo
    case inimigos[i].dirMov of
      idNordeste: inimigos[i].CurFrame:= PDNORDESTE;
      idNoroeste: inimigos[i].CurFrame:= PDNOROESTE;
      idSudoeste: inimigos[i].curFrame:= PDSUDOESTE;
      idSudeste: inimigos[i].curFrame:= PDSUDESTE;
    end;

    //testar contra coliso coliso com as bordas
    if (inimigos[i].DirMov = idNordeste) and
       (inimigos[i].CellY = 0) then continue;
    if (inimigos[i].dirMov = idNoroeste) and
       (inimigos[i].cellx = 0) then continue;
    if (inimigos[i].dirMov = idSudoeste) and
       (inimigos[i].CellY = engine.MaxLinhas-1) then continue;
    if (inimigos[i].dirMov = idSudeste) and
       (inimigos[i].CellX = engine.MaxColunas-1) then continue;

    //testar para no andar para dentro da rodovia
    if (inimigos[i].DirMov = idNordeste) and
       (inimigos[i].CellY = 6) then continue;
    if (inimigos[i].DirMov = idSudoeste) and
       (inimigos[i].CellY = 3) then continue;

    //guardar em P a posio futura
    case inimigos[i].DirMov of
      idNordeste: begin
        p.x:= inimigos[i].cellx;
        p.y:= inimigos[i].celly -1;
      end;
      idNoroeste: begin
        p.x:= inimigos[i].cellx - 1;
        p.y:= inimigos[i].celly;
      end;
      idSudeste: begin
        p.x:= inimigos[i].cellx + 1;
        p.y:= inimigos[i].celly;
      end;
      idSudoeste: begin
        p.x:= inimigos[i].cellx;
        p.y:= inimigos[i].celly + 1;
      end;
     end;

    //testar para no atravessar qualquer cenrio
    if engine.IsoCelula[p.x, p.y].Frames.Ativa = true
    then continue;

    //testar coliso com batman na posio futura
    if (batman.CellX = p.x) and (batman.CellY = p.y)
    then begin
      perdeu:= true;
      exit;
    end;

    //pegar os frames de incio e fim da animao
    // baseado na direo em que o inimigo est virado
    case inimigos[i].DirMov of
      idNordeste: begin
        inimigos[i].IniFrame:= IFNORDESTE;
        inimigos[i].FimFrame:= FFNORDESTE;
      end;
      idNoroeste: begin
        inimigos[i].IniFrame:= IFNOROESTE;
        inimigos[i].FimFrame:= FFNOROESTE;
      end;
      idSudoeste: begin
        inimigos[i].IniFrame:= IFSUDOESTE;
        inimigos[i].FimFrame:= FFSUDOESTE;
      end;
      idSudeste: begin
        inimigos[i].IniFrame:= IFSUDESTE;
        inimigos[i].FimFrame:= FFSUDESTE;
      end;
    end;
    inimigos[i].Mover(inimigos[i].dirmov, true, 7, true, 1);
  end;
end;


////////////////////////////////////////////////////////////////////////////////
procedure TForm1.CarregarBase(nome: string);
var
  arq: TStringList;
  totTiles: integer;
  i, x, y: integer;
  str: TParsedString;
  NomeTiles: array[0..MAXTILES -1] of string;
begin
  //criar e carregar arquivo
  arq:= TStringList.create;
  arq.LoadFromFile(nome);
  //ler o nmero de tiles
  totTiles:= strToInt(arq[0]);
  //pegar nomes das figuras dos tiles
  for i:= 0 to totTiles -1 do nomeTiles[i]:= arq[i + 1];
  //montar mapa
  for y:= 0 to engine.MaxLinhas -1 do begin
    str:= ParseString(arq[y + totTiles + 1], ':');
    for x:= 0 to engine.MaxColunas -1 do begin
      i:= strToInt(str.strings[x]);
      engine.IsoCelula[x, y].CarregarBase(nomeTiles[i]);
      //para que o cho esteje em um ponto mais elevado
      //devemos aumentar o offsety de todos os tiles
      engine.isoCelula[x, y].z:= -10;
    end;
  end;
  engine.CalcPreBuffer;
  arq.free;
end;


////////////////////////////////////////////////////////////////////////////////
procedure TForm1.CarregarCenario(nome: string);
var
  arq: TStringList;
  totTiles: integer;
  NomeTiles: array[0..MAXTILES -1] of string;
  i, x, y: integer;
  str: TParsedString;
begin
  //criar e carregar arquivo
  arq:= TStringList.create;
  arq.LoadFromFile(nome);
  //ler o nmero de figuras
  totTiles:= strToInt(arq[0]);
  //pegar nomes das figuras
  for i:= 0 to totTiles -1 do nomeTiles[i]:= arq[i + 1];
  //montar o cenrio
  for y:= 0 to engine.MaxLinhas -1 do begin
    str:= ParseString(arq[y + totTiles + 1], ':');
    for x:= 0 to engine.MaxColunas -1 do begin
      i:= strToInt(str.strings[x]);
      if i = 0 then continue;
      engine.IsoCelula[x, y].CarregarAnim(nomeTiles[i -1],
                              30, amAnimacao, true, true);
    end;
  end;
  arq.free;
end;


////////////////////////////////////////////////////////////////////////////////
procedure TForm1.EngineInitialize(Sender: TObject);
var
  i: integer;
  p: TPoint;
begin
  //carregar mapa
  carregarBase('mapa.bse');
  carregarCenario('mapa.cen');

  //carregar batman
  batman:= engine.CarregarMovObj('batman.bmp', 24,
                    false, false, engine.AcharPixel(4,3), true);

  //o primeiro frame tem essa direo
  batman.DirMov:= idSudeste;

  //carregar bomba
  bomba:= engine.CarregarMovObj('bomba.bmp', 14, true, false, point(0, 0), true);
  bomba.FimFrame:= 2; //o ltimo frame da animao
  bomba.CurFrame:= 3; //frame vazio

  //criar monstros
  i:= 0;
  while i < MAXINIMIGOS do begin
    p.x:= random(10);
    p.y:= random(10);

    //testar cenrio
    if (p.y = 4) or (p.y = 5) or
       (engine.IsoCelula[p.x, p.y].AnimMode <> amNone)
       then continue;
    inimigos[i]:= Engine.CarregarMovObj('monstro.bmp', 24,
             false, false, engine.acharPixel(p.x,p.y), true);
    inc(i);
  end;
end;


////////////////////////////////////////////////////////////////////////////////
procedure TForm1.TimerTimer(Sender: TObject; LagCount: Integer);
begin
  Input.Update;
  if perdeu = false then begin
    MoverBatman;
    //quando pulando, precisamos aumentar o Z do
    //batman para dar a impresso do movimento
    if pulando then
           batman.Z:= -sqr(batman.posmov -7) + 49;
    MoverMonstros;
    Engine.Renderizar;
  end else begin
    Engine.Renderizar;
    Engine.surface.Canvas.Font.Size:= 22;
    Engine.surface.canvas.font.Color:= clRed;
    Engine.surface.canvas.TextOut(150,100,'Voc perdeu!!!');
    Engine.surface.canvas.TextOut(200,150,'Score: '+intToStr(score));
    Engine.Surface.Canvas.Release;
  end;
  Engine.Flip;
end;


////////////////////////////////////////////////////////////////////////////////
procedure TForm1.EngineAcabouMovimento(var MovObj: TMovObj);
begin
  //fazer a bomba desaparecer
  if movObj = bomba then bomba.CurFrame:= 3;

  if movObj <> batman then exit;
  case batman.DirMov of
    idNordeste: batman.CurFrame:= PDNORDESTE;
    idNoroeste: batman.CurFrame:= PDNOROESTE;
    idSudoeste: batman.curFrame:= PDSUDOESTE;
    idSudeste: batman.curFrame:= PDSUDESTE;
  end;
  //desligar pulo
  if pulando = true then pulando:= false;
end;

end.
