unit bird;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls, MMSystem;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Notebook1: TNotebook;
    Tela: TImage;
    Ave2: TImage;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Ave2m: TImage;
    Fun: TImage;
    Nuvem: TImage;
    Nuve2: TImage;
    Mira0: TImage;
    Mirax: TImage;
    Label4: TLabel;
    Alvo1: TImage;
    Alvo2: TImage;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label11: TLabel;
    ListBox1: TListBox;
    Label12: TLabel;
    Edit1: TEdit;
    Label13: TLabel;
    Tlp: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure TelaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TelaMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
  public

  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

const
  Jog: integer = -1;
  Mx: integer = 0;
  My: integer = 0;
  Ax: integer = 145;
  Ay: integer = 50;
  Acertos: integer = 0;
  TotAves: integer = 1;
  Municao: integer = 50;

var
  Lx,Ly: integer;
  Lk: byte;
  PatGr: string;
  Vz: bool;
  Tiro: array[0..4] of TPoint;
  Alvo: array[0..4] of integer;

procedure Tocar(Nome: string);
var
  Som: array[0..79] of char;
begin
  StrPCopy(Som, Nome+'.wav');
  if Nome = 'acerta' then sndPlaySound(Som, snd_ASync)
  else sndPlaySound(Som, snd_ASync+snd_Nostop);
end;

//=== Inicializa o aplicativo ==================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  if FileExists('jogo.txt')
  then ListBox1.Items.LoadFromFile('jogo.txt');
  PatGr:= ExtractFilePath(Application.ExeName);
  Form1.ClientWidth:= 320;
  Form1.ClientHeight:= 188;
  Notebook1.PageIndex:= 2;
  Notebook1.Color:= clAqua;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  Randomize;
end;

//=== Termina o aplicativo =====================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  ListBox1.Items.SaveToFile('jogo.txt');
  //...>>>
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Lx:= X; Ly:= Y; Lk:= 1;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Lk = 1 then begin
    if X > Lx then Form1.Left:= Form1.Left + (X - Lx);
    if X < Lx then Form1.Left:= Form1.Left - (Lx - X);
    if Y > Ly then Form1.Top:= Form1.Top + (Y - Ly);
    if Y < Ly then Form1.Top:= Form1.Top - (Ly - Y);
  end;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Lk:= 0;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const
  Frame: array[0..3] of integer = (0,4,1,6);
  AveLf: array[0..3] of integer = (10,-100,-200,-300);
  AveTp: array[0..3] of integer = (15,0,0,0);
  Dist: array[0..3] of byte = (5,1,3,2);
  Queda: array[0..3] of boolean = (false,false,false,false);
var
  Buf: TBitmap;
  Tm,Tp: integer;
begin
  for Tm:= 0 to 3 do if Queda[Tm] then begin
    Frame[Tm]:= 3;
    AveTp[Tm]:= AveTp[Tm] + 7;
    if AveTp[Tm] > 188 then begin
      AveLf[Tm]:= 790;
      Queda[Tm]:= false;
    end;
  end else AveLf[Tm]:= AveLf[Tm] + Dist[Tm];
  for Tm:= 0 to 3 do if AveLf[Tm] > 780 then begin
    AveLf[Tm]:= -73; Queda[Tm]:= false;
    AveTp[Tm]:= Random(Notebook1.Height - Ave2.Height);
    Dist[Tm]:= Random(5) + 1;
    TotAves:= TotAves + 1;
    Label7.Caption:= IntToStr(TotAves);
  end;
  Buf:= TBitmap.Create;
  Buf.LoadFromFile('fundo.bmp');
  BitBlt(Buf.Canvas.Handle,320,35,233,43,Nuve2.Canvas.Handle,0,0,srcand);

  for Tm:= 0 to 3 do begin
    StretchBlt(Buf.Canvas.Handle,AveLf[Tm],AveTp[tm],
             (73 div 5) * Dist[Tm],(67 div 5) * Dist[Tm],
             Ave2m.Canvas.Handle,Frame[Tm]*73,0,73,67,srcand);

    StretchBlt(Buf.Canvas.Handle,AveLf[Tm],AveTp[Tm],
             (73 div 5) * Dist[Tm],(67 div 5) * Dist[Tm],
             Ave2.Canvas.Handle,Frame[Tm]*73,0,73,67,srcpaint);
    Frame[Tm]:= Frame[Tm]+1; if Frame[Tm] = 8 then Frame[Tm]:= 0;
  end;

  BitBlt(Buf.Canvas.Handle,320,35,233,43,Nuvem.Canvas.Handle,0,0,srcpaint);
  for Tm:= 0 to 4 do if Alvo[Tm] > 0 then begin
    Buf.Canvas.Brush.Color:= clBlack;
    Buf.Canvas.FillRect(bounds(Tiro[Tm].x,Alvo[Tm],2,2));
    for Tp:= 0 to 3 do
    if (Tiro[Tm].x > AveLf[Tp] + (5 * Dist[Tp])) and
       (Tiro[Tm].x < AveLf[Tp] + (14 * Dist[Tp])) and
       (Alvo[Tm] > AveTp[Tp] + (5 * Dist[Tp])) and
       (Alvo[Tm] < AveTp[Tp] + (8 * Dist[Tp])) and
       (Queda[Tp] = false) then begin
       //Acertou a ave...
       Alvo[Tm]:= 0;
       inc(Acertos);
       Tocar('acerta');
       Label8.Caption:= IntToStr(Acertos);
       Queda[Tp]:= true;
    end;
    if Alvo[Tm] <= Tiro[Tm].y then Alvo[Tm]:= 0 else dec(Alvo[tm],7);
  end else Alvo[Tm]:= 0;

  BitBlt(Buf.Canvas.Handle,Mx,My,320,188,Mirax.Canvas.Handle,0,0,srcand);
  BitBlt(Buf.Canvas.Handle,Mx,My,320,188,Mira0.Canvas.Handle,0,0,srcpaint);
  Tela.Canvas.CopyRect(bounds(0,0,320,188),Buf.Canvas,bounds(Mx,My,320,188));
  Buf.Free;
end;

procedure TForm1.Label3Click(Sender: TObject);
begin
  Notebook1.PageIndex:= 3;
end;

procedure TForm1.TelaMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Tm: integer;
begin
  Lx:= X; Ly:= Y;
  if (ssLeft in Shift) and
     (Mirax.Canvas.Pixels[X,Y] = clWhite) then begin
     if Municao = 0 then begin
       Tocar('sembala');
       exit;
     end;
     for Tm:= 0 to 4 do if Alvo[Tm] = 0 then begin
       Tiro[Tm].x:= Mx + X;
       Tiro[Tm].y:= My + Y;
       Alvo[Tm]:= My + 185;
       dec(Municao);
       Label10.Caption:= IntToStr(Municao);
       Tocar('tiro024');
       exit;
     end;
  end;
end;

procedure TForm1.TelaMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Mirax.Canvas.Pixels[X,Y] = clWhite then Tela.Cursor:= crSqlWait
  else Tela.Cursor:= crArrow;
  if ssRight in Shift then begin
    if X > Lx then Mx:= Mx + (X - Lx);
    if X < Lx then Mx:= Mx - (Lx - X);
    if Mx < -56 then Mx:= -56;
    if Mx > 516 then Mx:= 516;
    if Y > Ly then My:= My + (Y - Ly);
    if Y < Ly then My:= My - (Ly - Y);
    if My < 0 then My:= 0;
    if My > 68 then My:= 68;
    Lx:= X; Ly:= Y;
  end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
var
  Tm: integer;
begin
  if key= chr(vk_Escape) then
    if notebook1.PageIndex<>2
   then notebook1.PageIndex:=2
   else  application.Terminate;

  if (Key = char(VK_SPACE)) and
     (Notebook1.PageIndex = 0) and
     (Municao > 0) then begin
     for Tm:= 0 to 4 do if Alvo[Tm] = 0 then begin
       Tiro[Tm].x:= Mx + Ax + 15;
       Tiro[Tm].y:= My + Ay + 15;
       Alvo[Tm]:= My + 185;
       dec(Municao);
       Label10.Caption:= IntToStr(Municao);
       Tocar('tiro024');
       exit;
     end;
  end else Tocar('sembala');
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  S: string;
  Tm: integer;
begin
  if Municao > 0 then exit;
  Notebook1.PageIndex:= 3;
  Form1.ClientHeight:= 188;
  S:= '00000'+IntToStr(Acertos);
  ListBox1.Items[Jog]:= copy(S,length(S)-4,5)+' '+Edit1.Text;
  Tlp.Items.Assign(ListBox1.Items);
  ListBox1.Items.Clear;
  Tm:= Tlp.Items.Count-1;
  while Tm > 0 do begin
    ListBox1.Items.Add(Tlp.Items[Tm]);
    dec(Tm);
  end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
var
  Tm: integer;
begin
  if Edit1.Text = '' then begin
    Label11.Caption:= 'Defina um nome!';
    exit;
  end;
  //Verificar se o jogador j est cadastrado
  Jog:= -1;
  for Tm:= 0 to ListBox1.Items.Count -1 do
  if pos(Edit1.Text,ListBox1.Items[Tm]) <> 0 then Jog:= Tm;
  //Se Jog =-1, no existe jogador
  if Jog >-1 then begin
    //Recupera os dados deste jogador
    Acertos:= StrToInt(copy(ListBox1.Items[Jog],1,5));
  end else begin
    //Caso contrrio, inclua novo jogador
    Acertos:= 0;
    ListBox1.Items.Add('00000 '+Edit1.Text);
    Jog:= ListBox1.Items.Count-1;
  end;
  Label8.Caption:= IntToStr(Acertos);
  Notebook1.PageIndex:= 0;
  Form1.ClientWidth:= 320;
  Form1.ClientHeight:= 210;
  Form1.Color:= clBlack;
  Tocar('armar');
  Municao:= 50;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  Edit1.Text:= copy(ListBox1.Items[ListBox1.ItemIndex],7,100)
end;

end.

