unit Unitaero6;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Ceu: TImage;
    Aerop: TImage;
    Aviao: TImage;
    Timer1: TTimer;
    Radar: TImage;
    Timer2: TTimer;
    Caixa: TImage;
    Bomba: TImage;
    Radax: TImage;
    Torre: TImage;
    procedure FormActivate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure CeuClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

var
  //Coordenadas de linha e coluna da posio do avio:
  LinAvi,ColAvi: integer;
  //Flag que indica se o avio est voando (0) ou no:
  Favi: byte;
  //Margem para a imagem da posio do radar:
  PosRad: byte;
  Pista: string;
  //  Na string, cada caracter corresponder  a uma matriz
  //  de 8x8 pixels, na pista. Se o caracter for "." no
  //  tem caixa, se for "X", tem uma caixa na posio ---
  //Coordenadas da bomba:
  LinBom,ColBom: integer;
  ExpAvi,ExpRad,ExpTor: byte;
  //    Flags que mostram o estado dos elementos. Se
  //    for 0, ento o elemento est em seu estado normal.
  //    Se for de 1 a 5, indica em qual quadro da exploso
  //    o elemento se encontra. E se for 255, ento j
  //    terminou a exploso.
  //    A exploso do avio ser acrescentada ao Timer1
  //    e as exploses do radar e da torre ao Timer2

procedure MontaPista;
var
  HCeu,HAerop: HBitmap;
begin
  //Pinta o "cu" de azul claro:
  Form1.Ceu.Canvas.Brush.Color:= clAqua;
  Form1.Ceu.Canvas.Pen.Color:= clAqua;
  Form1.Ceu.Canvas.Rectangle(0,0,640,238);
  //Handles para o cu e para a pista:
  HCeu:= Form1.Ceu.Canvas.Handle;
  HAerop:= Form1.Aerop.Canvas.Handle;
  //Coloca a pista na rea do cu:
  BitBlt(HCeu,0,192,640,46,HAerop,0,0,srccopy);
end;

procedure TForm1.FormActivate(Sender: TObject);
var
  PosCai,Qtas: integer;
  HCeu,HCaixa: HBitmap;
begin
  Favi:= 255;
  PosRad:= 0;
  LinBom:= 0; ColBom:= 0;
  //   Vamos convencionar que, se LinBom = 0, ento
  //   no h bomba caindo - s poder cair uma bomba
  //   de cada vez
  MontaPista;
  HCeu:= Ceu.Canvas.Handle;
  HCaixa:= Caixa.Canvas.Handle;
  //--- 54 caracteres ".":
  Pista:='......................................................';
  //At 6 caixas sero colocadas na pista:
  for Qtas:= 1 to 6 do begin
    //"Sorteia uma posio:
    PosCai:= (Random(25)*2)+4;
    Pista[PosCai]:= 'X'; PosCai:= PosCai * 8 + 104;
    //Coloca a caixa na posio:
    BitBlt(HCeu,PosCai,200,8,8,HCaixa,0,0,SRCCOPY);
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  HCeu,HAvi,HBom: HBitmap;
  Trem,Clsp: Integer;
begin
  if Favi = 0 then begin
    Trem:= 0;
    //Se o avio estiver abaixo da coordenada 160,
    //ento use a matriz com trem de pouso:
    if LinAvi > 160 then Trem:= 96;
    HCeu:= Ceu.Canvas.Handle;
    HAvi:= Aviao.Canvas.Handle;
    HBom:= Bomba.Canvas.Handle;
    //Se tem boma caindo:
    if LinBom > 0 then begin
      //Coloca a bomba na posio:
      BitBlt(HCeu,ColBom,LinBom,12,4,HBom,0,0,SRCCOPY);
      //Para baixo e para a direita:
      ColBom:= ColBom+4; LinBom:= LinBom + 2;
      //Se saiu da tela, passa para o lado esquerdo:
      if ColBom > 640 then ColBom:= ColBom-704;
      //Se a bomba estiver sobre a pista de pouso:
      if (LinBom = 206) and (ColBom > 111) and
         (ColBom < 548) then begin
        //Apaga a bomba na pista:
        BitBlt(HCeu,ColBom-4,LinBom,12,2,HBom,0,0,SRCCOPY);
        //Apaga o caracter na string da pista:
        Clsp:= (ColBom div 8)-13; Pista[Clsp]:= '.';
        //Desliga a bomba:
        Pista[Clsp+1]:= '.'; LinBom:= 0;
      end;

     //Testa as proximidades do radar e se a bomba
     //estiver por perto, ativa a exploso:
     if (LinBom > 206) and (ColBom > 20) and (ColBom < 40)
       and (ExpRad < 255) then begin
       ExpRad:= 1; LinBom:= 0;
     end;
     //Testa as proximidades da torre e se a bomba
     //estiver por perto, ativa a exploso
     if (LinBom > 190) and (ColBom > 590) and (ColBom < 630)
       and (ExpTor < 255) then begin
       ExpTor:= 1; LinBom:= 0;
     end;


      //--- marca 2 ---

      //Apaga a bomba se passar a pista de pouso:
      if LinBom > 213 then begin
        BitBlt(HCeu,ColBom-4,LinBom,12,2,HBom,0,0,SRCCOPY);
        LinBom:= 0;
      end;
    end;
   //Desenhe o avio na sua posio apenas se estiver
   //funcionando normalmente (ExpAvi = 0):
   if ExpAvi = 0 then
      BitBlt(HCeu,ColAvi,LinAvi,64,16,HAvi,0,Trem,SRCCOPY);
   //Monta a parte final da exploso e termina:
   if ExpAvi = 5 then begin
      BitBlt(HCeu,ColAvi,LinAvi,64,16,HAvi,0,80,SRCCOPY);
      ExpAvi:= 255; Favi:= 255;  end;
   //Monta a parte 4 da exploso:
   if ExpAvi = 4 then begin
      BitBlt(HCeu,ColAvi,LinAvi,64,16,HAvi,0,64,SRCCOPY);
      inc(ExpAvi); end;
   //Monta a parte 3 da exploso:
   if ExpAvi = 3 then begin
      BitBlt(HCeu,ColAvi,LinAvi,64,16,HAvi,0,48,SRCCOPY);
      inc(ExpAvi); end;
   //Monta a parte 2 da exploso:
   if ExpAvi = 2 then begin
      BitBlt(HCeu,ColAvi,LinAvi,64,16,HAvi,0,32,SRCCOPY);
      inc(ExpAvi); end;
   //Monta a parte 1 da exploso:
   if ExpAvi = 1 then begin
      BitBlt(HCeu,ColAvi,LinAvi,64,16,HAvi,0,16,SRCCOPY);
      inc(ExpAvi); end;
   //Se chegou no final, posio 192 x 480, desligue
   //a animao:
   if (LinAvi = 192) and (ColAvi = 480) then Favi:= 255;
   //Se o avio est na altura da pista, entre o seu
   //comeo e fim e tem uma caixa logo  sua frente,
   //ento comece a exploso (ExpAvi:= 1):
   if (LinAvi = 192) and (ColAvi > 56) and (Favi = 0) and
      (Pista[((ColAvi+56) div 8)-13] = 'X') then ExpAvi:= 1;


    //Desloca o avio para a direita 4 pixels:
    ColAvi:= ColAvi + 4;
    //Se passou da coluna 640, desa 16 pixels e ajuste
    //a coluna para "antes do zero" (-64):
    if ColAvi = 640 then begin
      ColAvi:= -64; LinAvi:= LinAvi + 16;
    end;
    //Atualiza a imagem na tela:
    Ceu.Repaint;
   end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
   HCeu,HRad,HRax,HTor: HBitmap;
begin
  if Favi = 0 then begin
    HCeu:= Ceu.Canvas.Handle;
    HRad:= Radar.Canvas.Handle;
    HRax:= Radax.Canvas.Handle;
    HTor:= Torre.Canvas.Handle;
    //Monta o radar na pista, se ele estiver ok:
    if ExpRad = 0 then begin
      BitBlt(HCeu,32,208,16,16,HRad,PosRad,0,SRCCOPY);
      inc(PosRad,16); if PosRad = 64 then PosRad:= 0;
    end;
    //Monta a parte final da exploso do radar:
    if ExpRad = 4 then begin
      BitBlt(HCeu,16,200,48,24,HRax,0,72,SRCCOPY);
      ExpRad:= 255;
    end;
    //Monta a parte 3 da exploso do radar:
    if ExpRad = 3 then begin
      BitBlt(HCeu,16,200,48,24,HRax,0,48,SRCCOPY);
      inc(ExpRad);
    end;
    //Monta a parte 2 da exploso do radar:
    if ExpRad = 2 then begin
      BitBlt(HCeu,16,200,48,24,HRax,0,24,SRCCOPY);
      inc(ExpRad);
    end;
    //Monta a parte 1 da exploso do radar:
    if ExpRad = 1 then begin
      BitBlt(HCeu,16,200,48,24,HRax,0,0,SRCCOPY);
      inc(ExpRad);
    end;
    //Monta a parte final da exploso da torre:
    if ExpTor = 5 then begin
      BitBlt(HCeu,592,184,48,32,HTor,192,0,SRCCOPY);
      ExpTor:= 255;
    end;
    //Monta a parte 4 da exploso da torre:
    if ExpTor = 4 then begin
      BitBlt(HCeu,592,184,48,32,HTor,144,0,SRCCOPY);
      inc(ExpTor);
    end;
    //Monta a parte 3 da exploso da torre:
    if ExpTor = 3 then begin
      BitBlt(HCeu,592,184,48,32,HTor,96,0,SRCCOPY);
      inc(ExpTor);
    end;
    //Monta a parte 2 da exploso da torre:
    if ExpTor = 2 then begin
      BitBlt(HCeu,592,184,48,32,HTor,48,0,SRCCOPY);
      inc(ExpTor);
    end;
    //Monta a parte 1 da exploso da torre:
    if ExpTor = 1 then begin
      BitBlt(HCeu,592,184,48,32,HTor,0,0,SRCCOPY);
      inc(ExpTor);
    end;
  end;
end;

procedure TForm1.CeuClick(Sender: TObject);
begin
  //Se no tem nenhum avio voando ainda:
  if Favi <> 0 then begin
    LinAvi:= 0; ColAvi:= -64; Favi:= 0;
    exit;
  end;
  //S ativa a bomba se no houver nenhuma outra caindo
  //e se o avio no estiver pousando:
  if (LinBom = 0) and (LinAvi <> 192) then begin
    //A boma  sai logo abaixo do avio:
    LinBom:= LinAvi+16; ColBom:= ColAvi+48;
  end;
end;

end.
